package com.javacodegeeks.akka.grpc;

import java.io.IOException;

import com.javacodegeeks.library.Library;
import com.javacodegeeks.library.LibraryHandlerFactory;
import com.typesafe.config.Config;
import com.typesafe.config.ConfigFactory;

import akka.actor.ActorSystem;
import akka.http.javadsl.ConnectHttp;
import akka.http.javadsl.Http;
import akka.http.javadsl.UseHttp2;
import akka.http.javadsl.settings.ServerSettings;
import akka.stream.ActorMaterializer;
import akka.stream.Materializer;

public class Starter {
    public static void main(String[] args) throws IOException, InterruptedException {
        final Config conf = ConfigFactory
            .parseString("akka.http.server.preview.enable-http2 = on")
            .withFallback(ConfigFactory.defaultApplication());

        // Akka ActorSystem Boot
        final ActorSystem system = ActorSystem.create("akka-grpc", conf);
        final Materializer materializer = ActorMaterializer.create(system);
        final Library library = new LibraryImpl(new LibraryServiceImpl());

        Http
            .get(system)
            .bindAndHandleAsync(
                LibraryHandlerFactory.create(library, materializer),
                ConnectHttp.toHost("127.0.0.1", 8686, UseHttp2.always()),
                ServerSettings.create(system),
                256,
                system.log(),
                materializer);
    }

}
