package com.javacodegeeks.finatra

import javax.inject.Singleton
import com.javacodegeeks.library.Book

@Singleton
class LibraryService {
  private[this] val books = scala.collection.mutable.Map[String, Book]()
  
  def addBook(book: Book): Book = {
    books += (book.isbn -> book)
    book
  }
  
  def removeBook(isbn: String): Boolean = books.remove(isbn) match {
    case Some(_) => true
    case _ => false
  }
  
  def findBook(isbn: String): Option[Book] = books.get(isbn)
  def getBooks(): List[Book] = books.values.toList
  def updateBook(isbn: String, book: Book): Book = addBook(book) 
}