package com.javacodegeeks.finatra

import com.twitter.finatra.thrift.exceptions.FinatraThriftExceptionMapper
import com.twitter.finatra.thrift.ThriftServer
import com.twitter.finatra.thrift.routing.ThriftRouter
import com.twitter.finatra.thrift.filters._

object LibraryServerMain extends LibraryServer

class LibraryServer extends ThriftServer {
  override val name = "library-server"
  
  override def configureThrift(router: ThriftRouter): Unit = {
    router
      .filter[LoggingMDCFilter]
      .filter[TraceIdMDCFilter]
      .filter[ThriftMDCFilter]
      .filter[AccessLoggingFilter]
      .filter[StatsFilter]
      .filter[ExceptionMappingFilter]
      .exceptionMapper[FinatraThriftExceptionMapper]
      .add[LibraryController]
  }
}