package com.javacodegeeks.restlet;

import org.restlet.Application;
import org.restlet.Component;
import org.restlet.Restlet;
import org.restlet.data.Protocol;
import org.restlet.routing.Router;

public class Starter extends Application {
    @Override 
    public synchronized Restlet createInboundRoot() { 
        final Router router = new Router(getContext());
        router.attach("/library/books/{isbn}", BookResource.class);
        router.attach("/library/books", BooksResource.class);
        return router;
    }
    
    public static void main( String[] args ) throws Exception {
        Component component = new Component();
        component.setName("Library Application");
        component.getServers().add(Protocol.HTTP, 8182);
        component.getClients().add(Protocol.CLAP);
        component.getDefaultHost().attach(new Starter());
        component.start();
    }
}
