package com.javacodegeeks.sangria

trait LibraryService {
    def getBooks(): List[Book]
    def addBook(book: Book): Book 
    def findBook(isbn: String): Option[Book]
    def removeBook(isbn: String ): Boolean
    def updateBook(isbn: String, book: Book): Book 
}

class LibraryServiceImpl extends LibraryService {
  private[this] val books = scala.collection.mutable.Map[String, Book]()
  
  def addBook(book: Book): Book = {
    books += (book.isbn -> book)
    book
  }
  
  def removeBook(isbn: String): Boolean = books.remove(isbn) match {
    case Some(_) => true
    case _ => false
  }
  
  def findBook(isbn: String): Option[Book] = books.get(isbn)
  def getBooks(): List[Book] = books.values.toList
  def updateBook(isbn: String, book: Book): Book = addBook(book) 
}