package com.javacodegeeks.spark;

import java.util.Collection;
import java.util.Optional;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;

public class LibraryServiceImpl implements LibraryService {
    private final ConcurrentMap<String, Book> books = new ConcurrentHashMap<>();

    @Override
    public Collection<Book> getBooks() {
        return books.values();
    }

    @Override
    public Book addBook(Book book) {
        books.put(book.getIsbn(), book);
        return book;
    }

    @Override
    public Optional<Book> findBook(String isbn) {
        return Optional.ofNullable(books.get(isbn));
    }

}
