package com.javacodegeeks.spark;

import static spark.Spark.get;
import static spark.Spark.path;
import static spark.Spark.post;

import javax.json.bind.JsonbBuilder;

import spark.ResponseTransformer;

public class Starter {
    public static ResponseTransformer json() {
        return JsonbBuilder.create()::toJson;
      }
    
    public static void main(String[] args) {
        final LibraryService libraryService = new LibraryServiceImpl();
        
        path("/library", () -> {
            get("/books", 
                (req, res) -> libraryService.getBooks(),
                json()
            );
            
            get("/books/:isbn", 
                (req, res) -> libraryService
                    .findBook(req.params(":isbn"))
                    .orElseGet(() -> {
                        res.status(404);
                        return null;
                    }), 
                json()
            );
            
            post("/books", 
                (req, res) -> libraryService
                    .addBook(JsonbBuilder.create().fromJson(req.body(), Book.class)),
                json()
            );
        });
    }
}
